﻿'Murmur Admin Console is a tool allowing the player administration of murmur servers
'Copyright (C) 2009  Matthew Minter (matt@masarand.com)

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Public Class MurmurAdminConsole
    Public LocalConnection As Boolean = False
    Public ConnectedServer As String = ""
    Public ConnectedServerUserName As String = ""
    Public ConnectedServerPassword As String = ""
    Public ConnectedServerAddress As String = ""
    Public ConnectedServerPort As String = ""
    Public ConnectedServerBus As String = "system"
    Public ConnectedServerNumber As Integer = 1
    Public CurrentlyConnected As Boolean = False

    Public Sub RefreshPlayerList()
        Dim PlayerGetter As SSHManager = New SSHManager
        PlayerList.Items.Clear()
        PlayerList.Items.AddRange(PlayerGetter.GetPlayerList(ConnectedServerUserName, ConnectedServerPassword, ConnectedServerAddress, ConnectedServerPort))
    End Sub

    Private Sub MurmurAdminConsole_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        ServerLabelBox.Width = ServerDetailsSplit.Panel2.Width - ServerLabelBox.Location.X - 5
        ServerUsernameBox.Width = ServerDetailsSplit.Panel2.Width - ServerUsernameBox.Location.X - 5
        ServerAddressBox.Width = ServerDetailsSplit.Panel2.Width - ServerAddressBox.Location.X - 5
        ServerBusBox.Width = ServerDetailsSplit.Panel2.Width - ServerBusBox.Location.X - 5

        EditPlayerEmailBox.Width = ViewEditPlayersSplit.Panel2.Width - EditPlayerEmailBox.Location.X - 5
        EditPlayerNameBox.Width = ViewEditPlayersSplit.Panel2.Width - EditPlayerNameBox.Location.X - 5
        EditPlayerPasswordBox.Width = ViewEditPlayersSplit.Panel2.Width - EditPlayerPasswordBox.Location.X - 5
    End Sub

    Private Sub AddServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddServer.Click
        Dim ServerAdder As ServerListManager = New ServerListManager
        ServerAdder.AddServer(ServerLabelBox.Text, ServerAddressBox.Text, ServerUsernameBox.Text, ServerPortBox.Text, ServerList)
    End Sub

    Private Sub MurmurAdminConsole_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        My.Computer.FileSystem.CurrentDirectory = My.Application.Info.DirectoryPath()
        Dim mydir As String = My.Computer.FileSystem.CurrentDirectory
        Dim datadir As String = mydir & "/data/"
        My.Computer.FileSystem.CopyFile(mydir & "/plink.exe", datadir & "plink.exe", True)
        If My.Computer.FileSystem.DirectoryExists(datadir) <> True Then
            '
            My.Computer.FileSystem.CreateDirectory(datadir)
            '
        End If
        If My.Computer.FileSystem.FileExists(datadir & "serverlist.txt") <> True Then
            '
            My.Computer.FileSystem.WriteAllText(datadir & "serverlist.txt", "", False)
            '
        End If
        Dim InitServerList As ServerListManager = New ServerListManager
        InitServerList.UpdateServerList(ServerList)
    End Sub

    Private Sub ServerList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ServerList.SelectedIndexChanged
        Dim FieldPopulator As ServerListManager = New ServerListManager
        If ServerList.SelectedItem.ToString <> "" Then
            FieldPopulator.PopulateFields(Convert.ToString(ServerList.SelectedItem()), ServerLabelBox, ServerAddressBox, ServerPortBox, ServerUsernameBox)
        End If
    End Sub

    Private Sub RemoveServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoveServer.Click
        Dim ServerRemover As ServerListManager = New ServerListManager
        ServerRemover.RemoveServer(Convert.ToString(ServerList.SelectedItem()), ServerList)
    End Sub

    Private Sub UpdateServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdateServer.Click
        Dim ServerEditer As ServerListManager = New ServerListManager
        If ServerLabelBox.Text <> "" And ServerAddressBox.Text <> "" And ServerUsernameBox.Text <> "" And ServerList.Items.Contains(ServerLabelBox.Text) <> True Then
            ServerEditer.RemoveServer(Convert.ToString(ServerList.SelectedItem()), ServerList)
            ServerEditer.AddServer(ServerLabelBox.Text, ServerAddressBox.Text, ServerUsernameBox.Text, ServerPortBox.Text, ServerList)
        Else
            FieldFill.ShowDialog()
        End If
    End Sub

    Private Sub Disconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Disconnect.Click
        '
        CurrentlyConnected = False
        ConnectedServer = ""
        ConnectedServerAddress = ""
        ConnectedServerUserName = ""
        ConnectedServerNumber = 1
        VserverNumber.Value = 1
        ServerBusBox.Text = "system"
        Me.ConnectToServer.Enabled = True
        PlayerListLabel.Text = "Player List"
        PlayerList.Items.Clear()
        EditPlayerEmailBox.Text = ""
        EditPlayerNameBox.Text = ""
        EditPlayerPasswordBox.Text = ""
        LocalConnection = False
        ''
    End Sub

    Private Sub ConnectToServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectToServer.Click
        If ServerAddressBox.Text = "" Or ServerUsernameBox.Text = "" Or ServerLabelBox.Text = "" Or ServerPortBox.Text = "" Then
            '
            FieldFill.ShowDialog()
            '
        Else
            '
            CurrentlyConnected = True
            ConnectedServer = ServerLabelBox.Text()
            ConnectedServerAddress = ServerAddressBox.Text()
            ConnectedServerUserName = ServerUsernameBox.Text()
            ConnectedServerPort = ServerPortBox.Text()
            ConnectedServerBus = ServerBusBox.Text()
            ConnectedServerNumber = VserverNumber.Value()
            ServerLoginForm.ShowDialog()
            Me.ConnectToServer.Enabled = False
            PlayerListLabel.Text = ConnectedServer & " Player List"
            RefreshPlayerList()
            '
            Tabs.SelectTab(ViewEditPlayers)
        End If
    End Sub

    Private Sub RemovePlayer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemovePlayer.Click
        UnregisterConfirm.ShowDialog()
    End Sub

    Private Sub PlayerList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PlayerList.SelectedIndexChanged
        Dim PlayerFinder As SSHManager = New SSHManager
        Dim RequestedPlayerName As String = PlayerFinder.UsernameToInfo(ConnectedServerUserName, ConnectedServerPassword, ConnectedServerAddress, ConnectedServerPort, PlayerList.SelectedItem(), 1)
        Dim RequestedPlayerEmail As String = PlayerFinder.UsernameToInfo(ConnectedServerUserName, ConnectedServerPassword, ConnectedServerAddress, ConnectedServerPort, PlayerList.SelectedItem(), 2)
        EditPlayerNameBox.Text = RequestedPlayerName
        EditPlayerEmailBox.Text = RequestedPlayerEmail
        EditPlayerPasswordBox.Text = ""
    End Sub

    Private Sub AddPlayerButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddPlayerButton.Click
        If CurrentlyConnected = True Then
            If EditPlayerEmailBox.Text <> "" And EditPlayerNameBox.Text <> "" And EditPlayerPasswordBox.Text <> "" Then
                Dim PlayerAdder As SSHManager = New SSHManager
                PlayerAdder.CreatePlayer(ConnectedServerUserName, ConnectedServerPassword, ConnectedServerAddress, ConnectedServerPort, EditPlayerNameBox.Text, EditPlayerEmailBox.Text, EditPlayerPasswordBox.Text)
            Else
                FieldFill.ShowDialog()
            End If
        Else
            ConnectToAServer.ShowDialog()
        End If
        RefreshPlayerList()
    End Sub

    Private Sub EditPlayer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditPlayer.Click
        If CurrentlyConnected = True Then
            If PlayerList.SelectedItem <> "" And EditPlayerEmailBox.Text <> "" And EditPlayerNameBox.Text <> "" And EditPlayerPasswordBox.Text <> "" Then
                Dim PlayeEditer As SSHManager = New SSHManager
                PlayeEditer.EditPlayer(ConnectedServerUserName, ConnectedServerPassword, ConnectedServerAddress, ConnectedServerPort, Convert.ToInt32(PlayeEditer.UsernameToInfo(ConnectedServerUserName, ConnectedServerPassword, ConnectedServerAddress, ConnectedServerPort, PlayerList.SelectedItem(), 0)), EditPlayerNameBox.Text, EditPlayerEmailBox.Text, EditPlayerPasswordBox.Text)
            Else
                FieldFill.ShowDialog()
            End If
        Else
            ConnectToAServer.ShowDialog()
        End If
        RefreshPlayerList()
    End Sub
End Class
